#include <iostream>
#include <queue>

using namespace std;

long BFS[1000][1000];
char Map[1000][1000];

void Init()
{
    for (long i = 0; i < 1000; i++)
    {
        for (long j = 0; j < 1000; j++)
        {
            BFS[i][j] = -1;
        }
    }
}

struct POINT
{
    long x;
    long y;
};

int main()
{
    Init();
    queue <POINT> Open;
    long W;
    long H;

    cin >> H;
    cin >> W;

    for (long y = 0; y < H; y++)
    {
        for (long x = 0; x < W; x++)
        {
            cin >> Map[x][y];
            if (Map[x][y] == 'S')
            {
                BFS[x][y] = 0;
                Open.push({x, y});
            }
        }
    }

    while (!Open.empty())
    {
        POINT E = Open.front();
        Open.pop();

        if (E.x != 0)
        {
            if (Map[E.x - 1][E.y] != 'x' && BFS[E.x - 1][E.y] == -1)
            {
                Open.push({E.x - 1, E.y});
                BFS[E.x - 1][E.y] = BFS[E.x][E.y] + 1;
            }
        }

        if (E.x != W - 1)
        {
            if (Map[E.x + 1][E.y] != 'x' && BFS[E.x + 1][E.y] == -1)
            {
                Open.push({E.x + 1, E.y});
                BFS[E.x + 1][E.y] = BFS[E.x][E.y] + 1;
            }
        }

        if (E.y != 0)
        {
            if (Map[E.x][E.y - 1] != 'x' && BFS[E.x][E.y - 1] == -1)
            {
                Open.push({E.x, E.y - 1});
                BFS[E.x][E.y - 1] = BFS[E.x][E.y] + 1;
            }
        }

        if (E.y != H - 1)
        {
            if (Map[E.x][E.y + 1] != 'x' && BFS[E.x][E.y + 1] == -1)
            {
                Open.push({E.x, E.y + 1});
                BFS[E.x][E.y + 1] = BFS[E.x][E.y] + 1;
            }
        }
    }

    for (long y = 0; y < H; y++)
    {
        for (long x = 0; x < W; x++)
        {
            if (Map[x][y] == 'T')
            {
                cout << BFS[x][y];
            }
        }
    }
}
